<?php
// ------------------------------------------------------------------------- //
// PHP UPLOAD TO MY FTP 1.0                                                  //
// ------------------------------------------------------------------------- //
// Copyright (C) 2002 Matthias ETIENNE <matt@php-test.com>                   //
// ------------------------------------------------------------------------- //
//  http://matt.phptest.free.fr/php_upload_to_my_ftp/                        //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //

include "config/config.php";             //inclusion de la config

if($closeApp==0){                        //redirection si l'application est ferme
header("Location:$redirectionPage");
exit;
}

include "includes/fonctions.inc.php";    //inclusion des fonctions
include "includes/header.php";           //inclusion de l'entete
if(file_exists("lang/$lang.php"))
include "lang/$lang.php";                //inclusion des mots
else
include "lang/fra.php";               

// inclusion de la classe de mail si necessaire
// inclusion of the mail class if necessary
if($prevenir_par_mail==1) include "includes/email_mime.class.php";

switch($a){

//----------------------------------------
// Page 1
//----------------------------------------
case ok:
$error_id=0;
$error_ftp=0;

//----------------------------------------
// Identification
//----------------------------------------
if($identification_nec==1){
	$identok = false;

	$motif = $login."|".$pass;
	if(in_array($motif, $user)) $identok = true;
	
	if($identok==false){
		echo $strBadLogin;
	   makeReturn();
		signMTA();
      exit;
   }
}
//----------------------------------------
// vrification du fichier
// file checking
//----------------------------------------
ereg("\.([^\.]*$)", $fichier_name, $elts);
$extension_fichier=$elts[1];

foreach($type_fichiers_auto as $ext){
	$str_ext .= ".$ext ";
}

if(!in_array($extension_fichier, $type_fichiers_auto)){
	echo $strErrorExtension." ".$str_ext."<br><br>";
   logError("Bad File extension ($extension_fichier) ");
   makeReturn();
   signMTA();
   exit;
}

if($fichier_size > $taille_max){
	echo $strErrorFilesize."<br><br>";
	logError("Bad File Size ($fichier_size) ");
   makeReturn();
   signMTA();
   exit;
}

//----------------------------------------
//Connection au serveur ftp
//Connection to the FTP server
//----------------------------------------
$connection_ftp=@ftp_connect("$ftp_server");
$login_to_ftp=@ftp_login($connection_ftp, $ftp_user, $ftp_pass);
if((!$connection_ftp) || (!$login_to_ftp)) ++$error_ftp;

if($error_ftp!=0){
echo $strErrorConnectionFtp."<br>";
logError("Can't connect to FTP server ($ftp_server) ");
makeReturn();
signMTA();
exit;
}

//----------------------------------------
//changement de dossier
//directory change
//----------------------------------------
if(isset($destination))
$dossier_destination = $destination;
else
$dossier_destination = $ftp_rep_defaut;

if(!@ftp_chdir($connection_ftp, $dossier_destination)){
echo $strErrorDestinationDirectory."<br><br>";
logError("Can't find destination directory (".$dossier_destination.") ");
makeReturn();
signMTA();
exit;
}

//---------------------------------------
// We verify that there is no file with 
// the same name that the uploaded file.
// If yes, we rename the new file.
//----------------------------------------
$arrayFilesInDir = ftp_nlist($connection_ftp, "./");
$renamed = false;

if(in_array($fichier_name, $arrayFilesInDir)){
	
	$chaine_type = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
   srand((double)microtime()*1000000);
	$code = '';
   for($i=0; $i<5; $i++)
   {
   // on gnre un mot de passe de 8 caractres
   $code.= $chaine_type[rand()%strlen($chaine_type)];
   }
	$newFileName = $code.$fichier_name;
	$renamed = true;

}else{
$newFileName = $fichier_name;
} 

//----------------------------------------
// File Upload
//----------------------------------------
$upload = ftp_put($connection_ftp, $newFileName, $fichier, FTP_BINARY);

//----------------------------------------
// Upload verification
//----------------------------------------

// Si Echec 
// If Upload Failed

if(!$upload){
	logError("Upload failed !");
	echo "<center><h1>Upload</h1>";
	echo $strErrorUploading." ".$newFileName."</center>";
	makeReturn();
   signMTA();
	
	$date_a=date("j/m/y  H:i", time());

	if($prevenir_par_mail==1){
		$mail = new mime_mail();
		$mail->to = "$email_a_prevenir";                
		$mail->subject = "[PHP UPLOAD]".$strErrorUploading." ".$newFileName;                   
	   $mail->body = $strErrorUploading." ".$newFileName."\n";
		$mail->body.= "Date: ".$date_a."<br>File: ".$newFileName."\n";
      $mail->body.= "IP: ".$REMOTE_ADDR."\n\n";
		$mail->body.="<a href='http://php-test.com/php_upload_to_my_ftp'>";
		$mail->body.="PHP Upload To my FTP</a>";
	   $mail->from = "PHP_UPLOAD_TO_MY_FTP@your-site.com";              
	   $mail->send();
	}
} 

// If upload OK
else{
	
	logUpload();

	echo "<center><h1>Upload</h1>".$strFile." ".$newFileName." (".$fichier_size." octets) ";
	echo $strHasBeenUploaded."<br></center><br><br>";
   
	makeReturn();
	signMTA();	
	
// Email 
	if($prevenir_par_mail==1){
		$mail = new mime_mail();
		$mail->to = "$email_a_prevenir";                
		$mail->subject = "[PHP UPLOAD]".$strNewFileUpload;
		$mail->body = $strYouReceive;
		$mail->body.= "\n--------------------------------------------------------------\n";
	   $mail->body.= $strFile." (".$newFileName.") ".$strHasBeenUploaded." (in ".$ftp_server.")";
		$mail->body.= "\n".$strInTheDirectory." ".$dossier_destination."\n"; 
 
      if($renamed)
			$mail->body.= $strFileRenamed."\n";

		$mail->body.= "\n\n-----------------------------------------------------------\n";
	   $mail->body.= "PHP Upload To mY FTP: http://www.php-test.com/php_upload_to_my_ftp/\n";
		$mail->from = "PHP_UPLOAD_TO_MY_FTP@your-site.com";
      
		if($joindre_fichier==1){
			$fichier_attache = fread(fopen("$fichier", "r"), filesize("$fichier"));
			$mail->attach("$fichier_attache", "$newFileName");
		}

	   $mail->send();
	}
}
break;

//----------------------------------------
// Page 2
//----------------------------------------
default:

logVisiteur();

echo "<FORM ENCTYPE='multipart/form-data' METHOD='POST' ACTION='index.php'>";
echo "<table class='Tableau' border='0' align='center' width='350'><tr>";
echo "<td width='100%' colspan='2'><p align='center'><font size='3'><b>";
echo $strUploadAFile."</b></font></p></td></tr>";
	
if($identification_nec == 1){
	echo "<tr><td width='103'><span style='font-size:10pt;'><font face='Arial' color='white'>";
   echo "Login :</font></span></td><td width='237'><input type='text' name='login' class='Forms'></td></tr>";
   echo "<tr><td width='103'><span style='font-size:10pt;'><font face='Arial' color='white'>";
   echo $strPassword." :</font></span></td><td width='237'><input type='password' name='pass' class='Forms'>";
   echo "</td></tr>";
} 

if($choisir_rep == 1){

	echo "<tr><td width='103'><span style='font-size:10pt;'><font face='Arial' color='white'>";
   echo $strDestDirectory." :</font></span></td><td width='237'>";

   $nb_rep_total = count($ftp_rep_choix);
   echo "<select name='destination' size='1' class='Forms'>";

   for($i=0; $i<$nb_rep_total; ++$i){
		echo "<option value='$ftp_rep_choix[$i]'>$ftp_rep_choix[$i]</option>";
   }

   echo "</select></td></tr>";
}

echo "<tr><td width='103'><span style='font-size:10pt;'><font face='Arial' color='white'>";
echo $strFileToUp."</font></span></td><td width='237'><input name='fichier' type='FILE' class='Forms'>";
echo "</td></tr><tr><td width='344' colspan='2'><p align='center'>";
echo "<INPUT TYPE='SUBMIT' VALUE='Upload' class='Forms' Onclick=\"this.value='$strWait'\">";
echo "</p></td></tr></table><input type='HIDDEN' name='a' value='ok'></FORM>";

signMTA();	

break;
}
?>
</body></html>